clang-tools 8.0.0

Public Member Functions | List of all members
clang::tidy::bugprone::TooSmallLoopVariableCheck Class Reference

This check gives a warning if a loop variable has a too small type which might not be able to represent all values which are part of the whole range in which the loop iterates. More...

`#include <TooSmallLoopVariableCheck.h>`

Inheritance diagram for clang::tidy::bugprone::TooSmallLoopVariableCheck:
[legend]
Collaboration diagram for clang::tidy::bugprone::TooSmallLoopVariableCheck:
[legend]

## Public Member Functions
| TooSmallLoopVariableCheck (StringRef Name, ClangTidyContext *Context)
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| The matcher for loops with suspicious integer loop variable. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...
virtual void | storeOptions (ClangTidyOptions::OptionMap &Options)
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

This check gives a warning if a loop variable has a too small type which might not be able to represent all values which are part of the whole range in which the loop iterates.

If the loop variable's type is too small we might end up in an infinite loop. Example:

long size = 294967296l;
for (short i = 0; i < size; ++i) {} { ... }

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/bugprone-too-small-loop-variable.html

Definition at line 31 of file TooSmallLoopVariableCheck.h.

## Constructor & Destructor Documentation

## ◆ TooSmallLoopVariableCheck()

clang::tidy::bugprone::TooSmallLoopVariableCheck::TooSmallLoopVariableCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Definition at line 33 of file TooSmallLoopVariableCheck.h.

References registerMatchers().

## Member Function Documentation

## ◆ check()

void clang::tidy::bugprone::TooSmallLoopVariableCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 137 of file TooSmallLoopVariableCheck.cpp.

References clang::tidy::bugprone::LoopIncrementName, clang::tidy::bugprone::LoopUpperBoundName, and clang::tidy::bugprone::LoopVarName.

## ◆ registerMatchers()

void clang::tidy::bugprone::TooSmallLoopVariableCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

The matcher for loops with suspicious integer loop variable.

In this general example, assuming 'j' and 'k' are of integral type:

for (...; j < 3 + 2; ++k) { ... }

The following string identifiers are bound to these parts of the AST: LoopVarName: 'j' (as a VarDecl) LoopVarCastName: 'j' (after implicit conversion) LoopUpperBoundName: '3 + 2' (as an Expr) LoopIncrementName: 'k' (as an Expr) LoopName: The entire for loop (as a ForStmt)

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 44 of file TooSmallLoopVariableCheck.cpp.

Referenced by TooSmallLoopVariableCheck().

The documentation for this class was generated from the following files:

- TooSmallLoopVariableCheck.h
- TooSmallLoopVariableCheck.cpp